## corectrl 1.5.2+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22)

project(CoreCtrl HOMEPAGE_URL "https://gitlab.com/corectrl/corectrl")
set(PROJECT_FQDN "org.corectrl.CoreCtrl")
set(PROJECT_VERSION 1.5.2)

include(GNUInstallDirs)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# add uninstall target
if(NOT TARGET uninstall)
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

  add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

set(CMAKE_CXX_STANDARD 20)

option (WITH_DEBUG_INFO "Add debug information (to Debug builds)" OFF)

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  add_definitions("-D_DEBUG")
  add_compile_options("-W;-Wall;-Wextra")
  add_compile_options("-Wno-redundant-move;-Wno-sign-compare")

  if (WITH_DEBUG_INFO)
    add_compile_options("-ggdb;-fno-omit-frame-pointer")
  endif()
endif()

# require libatomic on architectures without atomics support
include(CheckAtomic)
if(HAVE_CXX_ATOMICS_WITH_LIB OR HAVE_CXX_ATOMICS64_WITH_LIB)
  list(APPEND ATOMIC_LIB "atomic")
endif()

find_package(Qt6 6.8 COMPONENTS Core DBus Quick Charts Widgets Network Svg REQUIRED)
find_package(Qt6LinguistTools REQUIRED)
find_package(QuaZip-Qt6 1.0 REQUIRED)
find_package(spdlog 1.4 REQUIRED)
find_package(pugixml 1.11 REQUIRED)

find_package(Botan QUIET)
if(NOT Botan_FOUND)
  message(FATAL_ERROR "Botan library not found")
endif()

find_package(units 2.3.1 QUIET)
if(NOT units_FOUND)
  message("Using bundled units library")
  list(APPEND 3RDPARTY_INCLUDE_DIRECTORIES ${PROJECT_SOURCE_DIR}/3rdparty/units)
endif()
list(APPEND 3RDPARTY_DEFINITIONS
  UNIT_LIB_DISABLE_IOSTREAM
  DISABLE_PREDEFINED_UNITS
  ENABLE_PREDEFINED_DATA_UNITS
  ENABLE_PREDEFINED_ANGLE_UNITS
  ENABLE_PREDEFINED_TIME_UNITS
  ENABLE_PREDEFINED_ANGULAR_VELOCITY_UNITS
  ENABLE_PREDEFINED_FREQUENCY_UNITS
  ENABLE_PREDEFINED_VOLTAGE_UNITS
  ENABLE_PREDEFINED_POWER_UNITS
  ENABLE_PREDEFINED_TEMPERATURE_UNITS
  ENABLE_PREDEFINED_CONVERT_UNITS
  ENABLE_PREDEFINED_CONCENTRATION_UNITS
)

# Allow pci.ids path customization using -DWITH_PCI_IDS_PATH=<path-to-pci.ids-file> (#136)
set(WITH_PCI_IDS_PATH "/usr/share/hwdata/pci.ids" CACHE FILEPATH "Path to pci.ids file")

add_subdirectory(src)

# Tests
#
# NOTE: CTest provides a BUILD_TESTING option set by default to ON. This setting
# is useful for developers but not for most users, who will only waste time and
# energy compiling the testing suite when -DBUILD_TESTING=OFF is omitted at
# configuration time.
#
# Do not build the testing suite by default.
include(CTest)
option(BUILD_TESTING "Build the testing suite" OFF)
if(BUILD_TESTING)
  enable_testing()
  add_subdirectory(tests)
endif()

# Icons
string(TOLOWER "${PROJECT_NAME}" ICON_NAME)
foreach(ICON_SIZE 16 22 24 32 48 64 72 96 128 192 256)
  install(
    FILES resources/icon/app_${ICON_SIZE}.svg
    DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/icons/hicolor/${ICON_SIZE}x${ICON_SIZE}/apps
    RENAME ${ICON_NAME}.svg
  )
endforeach()

# .desktop file
install(
  FILES resources/launcher.desktop
  DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/applications
  RENAME ${PROJECT_FQDN}.desktop
)

# AppStream metadata
configure_file(resources/appdata.xml.in resources/appdata.xml)
install(
  FILES ${CMAKE_BINARY_DIR}/resources/appdata.xml
  DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/metainfo
  RENAME ${PROJECT_FQDN}.appdata.xml
)

=== src/CMakeLists.txt ===
configure_file(config.h.in config.h)

list(APPEND APP_COMPILE_DEFINITIONS
  ${3RDPARTY_DEFINITIONS}
  SPDLOG_ACTIVE_LEVEL=SPDLOG_LEVEL_TRACE
)

list(APPEND COMMON_SRC
  ${CMAKE_CURRENT_SOURCE_DIR}/common/fileutils.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/common/stringutils.cpp
)

list(APPEND CRYPTO_SRC
  ${CMAKE_CURRENT_SOURCE_DIR}/common/cryptolayer.cpp
)

list(APPEND CORE_SRC
  core/filecache.cpp
  core/profileiconcache.cpp
  core/commandqueue.cpp
  core/sysmodel.cpp
  core/sysexplorer.cpp
  core/sysmodelfactory.cpp
  core/sysmodelsyncer.cpp
  core/session.cpp
  core/profileview.cpp
  core/profilepartview.cpp
  core/profileviewfactory.cpp
  core/profilestorage.cpp
  core/profilexmlparserfactory.cpp
  core/profilepartxmlparserprovider.cpp
  core/profilexmlparser.cpp
  core/profilepartxmlparser.cpp
  core/profilemanager.cpp
  core/profile.cpp
  core/profilepart.cpp
  core/profilepartprovider.cpp
  core/profilefactory.cpp
  core/ccpro/zipdatasource.cpp
  core/ccpro/zipdatasink.cpp
  core/ccpro/ccproparser.cpp
  core/info/cpuinfo.cpp
  core/info/gpuinfo.cpp
  core/info/swinfo.cpp
  core/info/hwiddatasource.cpp
  core/info/hwidtranslator.cpp
  core/components/commonutils.cpp
  core/components/cpuutils.cpp
  core/components/amdutils.cpp
  core/components/gpu.cpp
  core/components/gpuprofilepart.cpp
  core/components/gpuxmlparser.cpp
  core/components/cpu.cpp
  core/components/cpuprofilepart.cpp
  core/components/cpuxmlparser.cpp
  core/components/controls/control.cpp
  core/components/controls/controlmode.cpp
  core/components/controls/controlmodeprofilepart.cpp
  core/components/controls/controlmodexmlparser.cpp
  core/components/controls/controlgroup.cpp
  core/components/controls/controlgroupprofilepart.cpp
  core/components/controls/controlgroupxmlparser.cpp
)

list(APPEND INFO_SRC
  core/info/infoproviderregistry.cpp
  core/info/common/cpuinfolscpu.cpp
  core/info/common/cpuinfoproccpuinfo.cpp
  core/info/common/gpuinfouevent.cpp
  core/info/common/gpuinforevision.cpp
  core/info/common/gpuinfoopengl.cpp
  core/info/common/gpuinfovulkan.cpp
  core/info/common/swinfokernel.cpp
  core/info/common/swinfomesa.cpp
  core/info/amd/gpuinfopm.cpp
  core/info/amd/gpuinfopmoverdrive.cpp
  core/info/amd/gpuinfovbios.cpp
  core/info/amd/gpuinfovram.cpp
  core/info/amd/gpuinfouniqueid.cpp
  core/info/amd/gpuinfoodfanctrl.cpp
)

list(APPEND CONTROLS_SRC
  core/components/controls/noop.cpp
  core/components/controls/noopprofilepart.cpp
  core/components/controls/noopxmlparser.cpp
  core/components/controls/gpucontrolprovider.cpp
  core/components/controls/amd/pm/handlers/ppdpmhandler.cpp
  core/components/controls/amd/pm/pmperfmodeprovider.cpp
  core/components/controls/amd/pm/pmperfmodeprofilepart.cpp
  core/components/controls/amd/pm/pmperfmodexmlparser.cpp
  core/components/controls/amd/pm/auto/pmauto.cpp
  core/components/controls/amd/pm/auto/pmautolegacy.cpp
  core/components/controls/amd/pm/auto/pmautor600.cpp
  core/components/controls/amd/pm/auto/pmautoprovider.cpp
  core/components/controls/amd/pm/auto/pmautoprofilepart.cpp
  core/components/controls/amd/pm/auto/pmautoxmlparser.cpp
  core/components/controls/amd/pm/fixed/pmfixed.cpp
  core/components/controls/amd/pm/fixed/pmfixedlegacy.cpp
  core/components/controls/amd/pm/fixed/pmfixedr600.cpp
  core/components/controls/amd/pm/fixed/pmfixedprovider.cpp
  core/components/controls/amd/pm/fixed/pmfixedprofilepart.cpp
  core/components/controls/amd/pm/fixed/pmfixedxmlparser.cpp
  core/components/controls/amd/pm/advanced/pmadvancedprovider.cpp
  core/components/controls/amd/pm/advanced/pmadvancedprofilepart.cpp
  core/components/controls/amd/pm/advanced/pmadvancedxmlparser.cpp
  core/components/controls/amd/pm/advanced/dynamicfreq/pmdynamicfreq.cpp
  core/components/controls/amd/pm/advanced/dynamicfreq/pmdynamicfreqprovider.cpp
  core/components/controls/amd/pm/advanced/dynamicfreq/pmdynamicfreqprofilepart.cpp
  core/components/controls/amd/pm/advanced/dynamicfreq/pmdynamicfreqxmlparser.cpp
  core/components/controls/amd/pm/advanced/fixedfreq/pmfixedfreq.cpp
  core/components/controls/amd/pm/advanced/fixedfreq/pmfixedfreqprovider.cpp
  core/components/controls/amd/pm/advanced/fixedfreq/pmfixedfreqprofilepart.cpp
  core/components/controls/amd/pm/advanced/fixedfreq/pmfixedfreqxmlparser.cpp
  core/components/controls/amd/pm/advanced/freqmode/pmfreqmodeprovider.cpp
  core/components/controls/amd/pm/advanced/freqmode/pmfreqmodeprofilepart.cpp
  core/components/controls/amd/pm/advanced/freqmode/pmfreqmodexmlparser.cpp
  core/components/controls/amd/pm/advanced/overclock/pmoverclockprovider.cpp
  core/components/controls/amd/pm/advanced/overclock/pmoverclockprofilepart.cpp
  core/components/controls/amd/pm/advanced/overclock/pmoverclockxmlparser.cpp
  core/components/controls/amd/pm/advanced/overclock/freqod/pmfreqod.cpp
  core/components/controls/amd/pm/advanced/overclock/freqod/pmfreqodprovider.cpp
  core/components/controls/amd/pm/advanced/overclock/freqod/pmfreqodprofilepart.cpp
  core/components/controls/amd/pm/advanced/overclock/freqod/pmfreqodxmlparser.cpp
  core/components/controls/amd/pm/advanced/overdrive/pmoverdrive.cpp
  core/components/controls/amd/pm/advanced/overdrive/pmoverdriveprovider.cpp
  core/components/controls/amd/pm/advanced/overdrive/pmoverdriveprofilepart.cpp
  core/components/controls/amd/pm/advanced/overdrive/pmoverdrivexmlparser.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqvolt/pmfreqvolt.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqvolt/pmfreqvoltprovider.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqvolt/pmfreqvoltprofilepart.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqvolt/pmfreqvoltxmlparser.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqrange/pmfreqrange.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqrange/pmfreqrangeprovider.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqrange/pmfreqrangeprofilepart.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqrange/pmfreqrangexmlparser.cpp
  core/components/controls/amd/pm/advanced/overdrive/voltcurve/pmvoltcurve.cpp
  core/components/controls/amd/pm/advanced/overdrive/voltcurve/pmvoltcurveprovider.cpp
  core/components/controls/amd/pm/advanced/overdrive/voltcurve/pmvoltcurveprofilepart.cpp
  core/components/controls/amd/pm/advanced/overdrive/voltcurve/pmvoltcurvexmlparser.cpp
  core/components/controls/amd/pm/advanced/overdrive/voltoffset/pmvoltoffset.cpp
  core/components/controls/amd/pm/advanced/overdrive/voltoffset/pmvoltoffsetprovider.cpp
  core/components/controls/amd/pm/advanced/overdrive/voltoffset/pmvoltoffsetprofilepart.cpp
  core/components/controls/amd/pm/advanced/overdrive/voltoffset/pmvoltoffsetxmlparser.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqoffset/pmfreqoffset.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqoffset/pmfreqoffsetprovider.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqoffset/pmfreqoffsetprofilepart.cpp
  core/components/controls/amd/pm/advanced/overdrive/freqoffset/pmfreqoffsetxmlparser.cpp
  core/components/controls/amd/pm/advanced/powerprofile/pmpowerprofile.cpp
  core/components/controls/amd/pm/advanced/powerprofile/pmpowerprofileprovider.cpp
  core/components/controls/amd/pm/advanced/powerprofile/pmpowerprofileprofilepart.cpp
  core/components/controls/amd/pm/advanced/powerprofile/pmpowerprofilexmlparser.cpp
  core/components/controls/amd/pm/advanced/powercap/pmpowercap.cpp
  core/components/controls/amd/pm/advanced/powercap/pmpowercapprovider.cpp
  core/components/controls/amd/pm/advanced/powercap/pmpowercapprofilepart.cpp
  core/components/controls/amd/pm/advanced/powercap/pmpowercapxmlparser.cpp
  core/components/controls/amd/pm/powerstate/pmpowerstate.cpp
  core/components/controls/amd/pm/powerstate/pmpowerstateprovider.cpp
  core/components/controls/amd/pm/powerstate/pmpowerstateprofilepart.cpp
  core/components/controls/amd/pm/powerstate/pmpowerstatexmlparser.cpp
  core/components/controls/amd/pm/powerstate/pmpowerstatemodeprovider.cpp
  core/components/controls/amd/pm/powerstate/pmpowerstatemodeprofilepart.cpp
  core/components/controls/amd/pm/powerstate/pmpowerstatemodexmlparser.cpp
  core/components/controls/amd/fan/fanmodeprovider.cpp
  core/components/controls/amd/fan/fanmodeprofilepart.cpp
  core/components/controls/amd/fan/fanmodexmlparser.cpp
  core/components/controls/amd/fan/auto/fanauto.cpp
  core/components/controls/amd/fan/auto/fanautoprovider.cpp
  core/components/controls/amd/fan/auto/fanautoprofilepart.cpp
  core/components/controls/amd/fan/auto/fanautoxmlparser.cpp
  core/components/controls/amd/fan/fixed/fanfixed.cpp
  core/components/controls/amd/fan/fixed/fanfixedprovider.cpp
  core/components/controls/amd/fan/fixed/fanfixedprofilepart.cpp
  core/components/controls/amd/fan/fixed/fanfixedxmlparser.cpp
  core/components/controls/amd/fan/curve/fancurve.cpp
  core/components/controls/amd/fan/curve/fancurveprovider.cpp
  core/components/controls/amd/fan/curve/fancurveprofilepart.cpp
  core/components/controls/amd/fan/curve/fancurvexmlparser.cpp
  core/components/controls/amd/fan/overdrive/auto/odfanauto.cpp
  core/components/controls/amd/fan/overdrive/auto/odfanautoprovider.cpp
  core/components/controls/amd/fan/overdrive/auto/odfanautoprofilepart.cpp
  core/components/controls/amd/fan/overdrive/auto/odfanautoxmlparser.cpp
  core/components/controls/amd/fan/overdrive/curve/odfancurve.cpp
  core/components/controls/amd/fan/overdrive/curve/odfancurveprovider.cpp
  core/components/controls/amd/fan/overdrive/curve/odfancurveprofilepart.cpp
  core/components/controls/amd/fan/overdrive/curve/odfancurvexmlparser.cpp
  core/components/controls/cpucontrolprovider.cpp
  core/components/controls/cpu/cpufreq.cpp
  core/components/controls/cpu/cpufreqprovider.cpp
  core/components/controls/cpu/cpufreqprofilepart.cpp
  core/components/controls/cpu/cpufreqxmlparser.cpp
  core/components/controls/cpu/cpufreqmodeprovider.cpp
  core/components/controls/cpu/cpufreqmodeprofilepart.cpp
  core/components/controls/cpu/cpufreqmodexmlparser.cpp
  core/components/controls/cpu/handlers/epphandler.cpp
)

list(APPEND SENSORS_SRC
  core/components/sensors/graphitemprofilepart.cpp
  core/components/sensors/graphitemxmlparser.cpp
  core/components/sensors/gpusensorprovider.cpp
  core/components/sensors/amd/gpufreq.cpp
  core/components/sensors/amd/memfreq.cpp
  core/components/sensors/amd/gputemp.cpp
  core/components/sensors/amd/junctiontemp.cpp
  core/components/sensors/amd/memorytemp.cpp
  core/components/sensors/amd/gpuvolt.cpp
  core/components/sensors/amd/power.cpp
  core/components/sensors/amd/activity.cpp
  core/components/sensors/amd/memusage.cpp
  core/components/sensors/amd/fanspeedrpm.cpp
  core/components/sensors/amd/fanspeedperc.cpp
  core/components/sensors/cpusensorprovider.cpp
  core/components/sensors/cpu/cpufreqpack.cpp
  core/components/sensors/cpu/cpuusage.cpp
  core/components/sensors/cpu/cpucoretemp.cpp
)

list(APPEND UI_COMPONENTS_SRC
  core/uifactory.cpp
  core/qmlitem.cpp
  core/profilemanagerui.cpp
  core/systeminfoui.cpp
  core/qmlcomponentfactory.cpp
  core/qmlcomponentregistry.cpp
  core/sysmodelqmlitem.cpp
  core/components/gpuqmlitem.cpp
  core/components/cpuqmlitem.cpp
  core/components/sensors/graphitem.cpp
  core/components/sensors/amd/gpufreqgraphitem.cpp
  core/components/sensors/amd/memfreqgraphitem.cpp
  core/components/sensors/amd/gputempgraphitem.cpp
  core/components/sensors/amd/junctiontempgraphitem.cpp
  core/components/sensors/amd/memorytempgraphitem.cpp
  core/components/sensors/amd/gpuvoltgraphitem.cpp
  core/components/sensors/amd/powergraphitem.cpp
  core/components/sensors/amd/activitygraphitem.cpp
  core/components/sensors/amd/memusagegraphitem.cpp
  core/components/sensors/amd/fanspeedrpmgraphitem.cpp
  core/components/sensors/amd/fanspeedpercgraphitem.cpp
  core/components/sensors/cpu/cpufreqpackgraphitem.cpp

=== tests/CMakeLists.txt ===
find_package(Catch2 3.0 REQUIRED)
find_package(trompeloeil 40 REQUIRED)

# Compile definitions
list(APPEND TESTS_COMPILE_DEFINITIONS
  ${3RDPARTY_DEFINITIONS}
  CATCH_CONFIG_FAST_COMPILE
  SPDLOG_ACTIVE_LEVEL=SPDLOG_LEVEL_TRACE
)

# include directories for all tests
list(APPEND TESTS_INCLUDE_DIRECTORIES
  ${3RDPARTY_INCLUDE_DIRECTORIES}
  ${PROJECT_SOURCE_DIR}/src
)

# catch main
add_library(catch_main OBJECT "src/main.cpp")
target_include_directories(catch_main PRIVATE ${TESTS_INCLUDE_DIRECTORIES})
target_compile_definitions(catch_main PRIVATE ${TESTS_COMPILE_DEFINITIONS})
target_link_libraries(catch_main PRIVATE
  spdlog::spdlog
  Catch2::Catch2
  trompeloeil::trompeloeil
  ${ATOMIC_LIB}
)

# test_* files
file(GLOB test_files "src/test_*.cpp")

# generate test_all executable
add_executable(test_all $<TARGET_OBJECTS:catch_main> ${test_files} ${3RDPARTY_SRC})
target_include_directories(test_all PRIVATE ${TESTS_INCLUDE_DIRECTORIES})
target_compile_definitions(test_all PRIVATE ${TESTS_COMPILE_DEFINITIONS})
target_link_libraries(test_all PRIVATE
  corectrl_lib
  Qt6::Core
  spdlog::spdlog
  $<$<BOOL:${units_FOUND}>:units::units>
  Catch2::Catch2
  trompeloeil::trompeloeil
  ${ATOMIC_LIB}
)

include(CTest)
include(Catch)
catch_discover_tests(test_all)

=== src/helper/CMakeLists.txt ===
find_package(PkgConfig REQUIRED)

find_package(Botan QUIET)
if(NOT Botan_FOUND)
  message(FATAL_ERROR "Botan library not found")
endif()


set(DBUS_DATADIR_PREFIX_DIR ${CMAKE_INSTALL_FULL_DATADIR})
option(INSTALL_DBUS_FILES_IN_PREFIX "Use installation prefix for D-Bus files" OFF)

# Find dbus
if(NOT INSTALL_DBUS_FILES_IN_PREFIX)
  pkg_check_modules(DBUS REQUIRED dbus-1)
  execute_process(
    COMMAND pkg-config --variable=datadir dbus-1
    RESULT_VARIABLE DBUS_DATADIR_PREFIX_DIR_RESULT
    OUTPUT_VARIABLE DBUS_DATADIR_PREFIX_DIR
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  if(NOT DBUS_DATADIR_PREFIX_DIR_RESULT EQUAL "0")
    message(FATAL_ERROR "Failed to retrieve D-Bus `datadir` variable using pkg-config")
  endif()
endif()
message("D-Bus files will be installed into ${DBUS_DATADIR_PREFIX_DIR}/dbus-1")

# Find polkit
pkg_check_modules(POLKIT REQUIRED polkit-gobject-1)

option(POLKIT_POLICY_INSTALL_DIR "Polkit policy files installation directory" OFF)
if(NOT POLKIT_POLICY_INSTALL_DIR)
  execute_process(
    COMMAND pkg-config --variable=policydir polkit-gobject-1
    RESULT_VARIABLE POLKIT_POLICY_INSTALL_DIR_RESULT
    OUTPUT_VARIABLE POLKIT_POLICY_INSTALL_DIR
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  if(NOT POLKIT_POLICY_INSTALL_DIR_RESULT EQUAL "0")
    message(FATAL_ERROR "Failed to retrieve Polkit `policydir` variable using pkg-config")
  endif()
endif()
message("Polkit policy files will be installed into ${POLKIT_POLICY_INSTALL_DIR}")

list(APPEND HELPER_COMPILE_DEFINITIONS
  SPDLOG_ACTIVE_LEVEL=SPDLOG_LEVEL_TRACE
)

list(APPEND PROCESS_MONITOR_SRC
  pmon/processmonitor.cpp
  pmon/procpidsolver.cpp
  pmon/nlprocexecsocket.cpp
  pmon/nlprocexecmonitor.cpp
  pmon/processregistry.cpp
  pmon/appregistry.cpp
  pmon/msgdispatcher.cpp
  pmon/processeventconnector.c
)

list(APPEND SYSTEM_CONTROL_SRC
  sysctl/sysfswriter.cpp
  sysctl/msgreceiver.cpp
)

set(CMAKE_AUTOMOC ON)
add_executable(corectrl_helperkiller
  helperkiller.cpp
  polkit.cpp
)
set(CMAKE_AUTOMOC OFF)

target_include_directories(corectrl_helperkiller PRIVATE
  ${POLKIT_INCLUDE_DIRS}
)
target_compile_definitions(corectrl_helperkiller PRIVATE ${HELPER_COMPILE_DEFINITIONS})
target_link_libraries(corectrl_helperkiller PRIVATE
  Qt6::Core
  Qt6::DBus
  spdlog::spdlog
  ${POLKIT_LIBRARIES}
  ${ATOMIC_LIB}
)

configure_file(org.corectrl.helperkiller.service.in org.corectrl.helperkiller.service)
install(TARGETS corectrl_helperkiller DESTINATION "${CMAKE_INSTALL_FULL_LIBEXECDIR}/corectrl")
install(FILES org.corectrl.helperkiller.conf DESTINATION "${DBUS_DATADIR_PREFIX_DIR}/dbus-1/system.d")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/org.corectrl.helperkiller.service" DESTINATION "${DBUS_DATADIR_PREFIX_DIR}/dbus-1/system-services")
install(FILES org.corectrl.helperkiller.policy DESTINATION "${POLKIT_POLICY_INSTALL_DIR}")

set(CMAKE_AUTOMOC ON)
add_executable(corectrl_helper
  helper.cpp
  polkit.cpp
  ${COMMON_SRC}
  ${CRYPTO_SRC}
  ${PROCESS_MONITOR_SRC}
  ${SYSTEM_CONTROL_SRC}
)
set(CMAKE_AUTOMOC OFF)

target_include_directories(corectrl_helper PRIVATE
  ${Botan_INCLUDE_DIRS}
  ${POLKIT_INCLUDE_DIRS}
  ${PROJECT_SOURCE_DIR}/src
)
target_compile_definitions(corectrl_helper PRIVATE ${HELPER_COMPILE_DEFINITIONS})
target_link_libraries(corectrl_helper PRIVATE
  Qt6::Core
  Qt6::DBus
  stdc++fs
  pthread
  spdlog::spdlog
  ${Botan_LIBRARIES}
  ${POLKIT_LIBRARIES}
  ${ATOMIC_LIB}
)

configure_file(org.corectrl.helper.service.in org.corectrl.helper.service)
install(TARGETS corectrl_helper DESTINATION "${CMAKE_INSTALL_FULL_LIBEXECDIR}/corectrl")
install(FILES org.corectrl.helper.conf DESTINATION "${DBUS_DATADIR_PREFIX_DIR}/dbus-1/system.d")
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/org.corectrl.helper.service" DESTINATION "${DBUS_DATADIR_PREFIX_DIR}/dbus-1/system-services")
install(FILES org.corectrl.helper.policy DESTINATION "${POLKIT_POLICY_INSTALL_DIR}")

=== debian/changelog ===
corectrl (1.5.2+ds-1) unstable; urgency=medium

  [ Jeremy Bícha ]
  * New upstream release
  * Move maintainership to Debian Multimedia team (Closes: #1118496)
  * debian/gbp.conf: fix upstream-vcs-tag field

  [ Sudip Mukherjee ]
  * d/rules: execute patchelf after dh_strip to fix FTBFS on Ubuntu

 -- Jeremy Bícha <jbicha@ubuntu.com>  Tue, 21 Oct 2025 13:56:36 -0400

=== debian/control ===
Source: corectrl
Section: utils
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Matthias Geiger <werdahias@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 catch2 (>= 3.0.0),
 cmake (>= 3.22),
 libbotan-3-dev,
 libunits-cpp-dev,
 libspdlog-dev (>= 1.4),
 libtrompeloeil-cpp-dev (>= 40),
 libdbus-1-dev,
 libpolkit-gobject-1-dev,
 libdrm-dev,
 libquazip1-qt6-dev,
 libpugixml-dev (>= 1.11),
 patchelf,
 qt6-base-dev (>= 6.8),
 qt6-declarative-dev (>= 6.8),
 qt6-charts-dev (>= 6.8),
 qt6-svg-dev (>= 6.8),
 qt6-tools-dev (>= 6.8),
Standards-Version: 4.7.2
Homepage: https://gitlab.com/corectrl/corectrl
Vcs-Browser: https://salsa.debian.org/debian/corectrl
Vcs-Git: https://salsa.debian.org/debian/corectrl.git

Package: corectrl
Architecture: linux-any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 vulkan-tools,
 qml6-module-qtcharts (>= 6.8),
 qml6-module-qtquick-layouts (>= 6.8),
 qml6-module-qtquick-controls (>= 6.8),
 qml6-module-qt-labs-platform (>= 6.8),
 qml6-module-qtquick-window (>= 6.8),
 qml6-module-qtquick (>= 6.8),
Description: Control your computer hardware using application profiles
 CoreCtrl allows control of the CPU and AMD GPUs to set custom profiles for
 applications. This aims to be flexible, comfortable and accessible to regular
 users.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
include /usr/share/dpkg/architecture.mk
DEBARCH:=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCatch2_DIR=/usr/lib/cmake/Catch2 \
	-DBUILD_TESTING=ON


override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/corectrl/usr/lib/$(DEBARCH)/corectrl/
	mv debian/corectrl/usr/lib/$(DEBARCH)/libcorectrl.so debian/corectrl/usr/lib/$(DEBARCH)/corectrl/

execute_after_dh_strip:
	patchelf --replace-needed libcorectrl.so /usr/lib/$(DEBARCH)/corectrl/libcorectrl.so debian/corectrl/usr/bin/corectrl

override_dh_dwz:
	@echo "BYE DWZ"
